--- src/Makefile.orig	2023-02-11 02:02:15
+++ src/Makefile	2023-02-11 02:03:06
@@ -43,7 +43,7 @@
 LUAC_O=	luac.o
 
 ALL_O= $(BASE_O) $(LUA_O) $(LUAC_O)
-ALL_T= $(LUA_A) $(LUA_T) $(LUAC_T)
+ALL_T= $(LUA_A) $(LUA_T) $(LUAC_T) $(MACPORTS_SHARED_LIB)
 ALL_A= $(LUA_A)
 
 # Targets start here.
@@ -55,15 +55,21 @@
 
 a:	$(ALL_A)
 
+%.dylib: $(BASE_O)
+	$(CC) -o $@ -dynamiclib $(LDFLAGS) $^ -install_name $(MACPORTS_PREFIX)/lib/$(MACPORTS_SHARED_LIB) -compatibility_version $(MACPORTS_BRANCH) -current_version $(MACPORTS_VERSION)
+
+%.so: $(BASE_O)
+	$(CC) -o $@ -shared $(LDFLAGS) $^ -ldl -lm -Wl,-soname,$(MACPORTS_SHARED_LIB)
+
 $(LUA_A): $(BASE_O)
 	$(AR) $@ $(BASE_O)
 	$(RANLIB) $@
 
-$(LUA_T): $(LUA_O) $(LUA_A)
-	$(CC) -o $@ $(LDFLAGS) $(LUA_O) $(LUA_A) $(LIBS)
+$(LUA_T): $(LUA_O) $(MACPORTS_SHARED_LIB)
+	$(CC) -o $@ $(LDFLAGS) $(LUA_O) $(MACPORTS_SHARED_LIB) $(LIBS)
 
-$(LUAC_T): $(LUAC_O) $(LUA_A)
-	$(CC) -o $@ $(LDFLAGS) $(LUAC_O) $(LUA_A) $(LIBS)
+$(LUAC_T): $(LUAC_O) $(MACPORTS_SHARED_LIB)
+	$(CC) -o $@ $(LDFLAGS) $(LUAC_O) $(MACPORTS_SHARED_LIB) $(LIBS)
 
 clean:
 	$(RM) $(ALL_T) $(ALL_O)
@@ -106,7 +112,7 @@
 	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_LINUX" SYSLIBS="-Wl,-E -ldl -lreadline"
 
 macosx:
-	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_MACOSX" SYSLIBS="-lreadline" CC=cc
+	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_MACOSX" SYSLIBS="-lreadline"
 
 mingw:
 	$(MAKE) "LUA_A=lua52.dll" "LUA_T=lua.exe" \
@@ -184,4 +190,3 @@
  lzio.h lmem.h ldo.h lfunc.h lgc.h lopcodes.h lstring.h ltable.h lvm.h
 lzio.o: lzio.c lua.h luaconf.h llimits.h lmem.h lstate.h lobject.h ltm.h \
  lzio.h
-
